#ifndef WATER_H
#define WATER_H

// Normal water without any interesting properties.
#define WATER_TYPE_NORMAL 0

// Water with current that pushes the player left.
#define WATER_TYPE_LEFT_CURRENT 1

// Water with current that pushes the player right.
#define WATER_TYPE_RIGHT_CURRENT 2

// Water with current that pushes the player up.
#define WATER_TYPE_UP_CURRENT 3

// Water with current that pushes the player down.
#define WATER_TYPE_DOWN_CURRENT 4

// Water causing the rate of oxygen depletion to increase.
#define WATER_TYPE_LOW_OXYGEN 5

// Water causing the rate of oxygen depletion to decrease.
#define WATER_TYPE_HIGH_OXYGEN 6

// Water with fast current that pushes the player left fast.
#define WATER_TYPE_FAST_LEFT_CURRENT 7

// Water with fast current that pushes the player right fast.
#define WATER_TYPE_FAST_RIGHT_CURRENT 8

// Water with fast current that pushes the player up fast.
#define WATER_TYPE_FAST_UP_CURRENT 9

// Water with fast current that pushes the player down fast.
#define WATER_TYPE_FAST_DOWN_CURRENT 10

// Water which kills the player.
#define WATER_TYPE_BIOHAZARD 11

// Water which moves upwards over time as part of implementing the Rainbow Islands gesture.
#define WATER_TYPE_CHASING 12

// Water which is initially empty but can be activated.
#define WATER_TYPE_INITIALLY_EMPTY 13

// Water which adds a significant amount of oxygen to the player.
#define WATER_TYPE_OXYGEN_ADD 14

// Water which depletes the player's oxygen to a low amount.
#define WATER_TYPE_OXYGEN_SUBTRACT 15

#endif